

source("misc-lib.R")

## TODO: Fix things like languages, country, etc. 

# read the key for held out data
ho.key <- read.table("HELD-OUT-key.txt", header=T)

subject.data.file <- "TurkData-Accuracy.txt";

p.code <- function(p) {
	if(p < 0.001) { return("***") }
	else if(p < 0.01) { return("**") }
	else if(p < 0.05) { return("*") }
	else { return("ns"); }
}
#TODO: Automatically mark close hypotheses!

# Data Assumptions: 
# - Reponse number starts at 0
concept.desc <- NULL
concept.class <- NULL # B=boolean, R=relational/quantificational NA=remove this from analysis (
concept.desc["hg01"] <- "True"
concept.class["hg01"] <- "B"
concept.desc["hg02"] <- "False"
concept.class["hg02"] <- "B"
concept.desc["hg03"] <- "Blue"
concept.class["hg03"] <- "B"
concept.desc["hg04"] <- "Circle"
concept.class["hg04"] <- "B"
concept.desc["hg05"] <- "Not circle"
concept.class["hg05"] <- "B"
concept.desc["hg06"] <- "Circle or blue"
concept.class["hg06"] <- "B"
concept.desc["hg07"] <- "Circle or triangle"
concept.class["hg07"] <- "B"
concept.desc["hg08"] <- "Blue or green"
concept.class["hg08"] <- "B"
concept.desc["hg09"] <- "Circle and blue"
concept.class["hg09"] <- "B"
concept.desc["hg10"] <- "Circle and not blue"
concept.class["hg10"] <- "B"
concept.desc["hg11"] <- "Not [circle and blue]"
concept.class["hg11"] <- "B"
concept.desc["hg12"] <- "Not [circle or blue]"
concept.class["hg12"] <- "B"
concept.desc["hg13"] <- "Circle and [not blue]";
concept.class["hg13"] <- "B";
concept.desc["hg14"] <- "Circle xor blue"
concept.class["hg14"] <- "B"
concept.desc["hg15"] <- "Not [circle xor blue]"
concept.class["hg15"] <- "B"
concept.desc["hg16"] <- "Circle xor [not blue]"
concept.class["hg16"] <- "B"
concept.desc["hg17"] <- "Everything iff triangle"
concept.class["hg17"] <- "R"
concept.desc["hg18"] <- "Size 3"
concept.class["hg18"] <- "B"
concept.desc["hg19"] <- "Size 2"
concept.class["hg19"] <- "B"
concept.desc["hg20"] <- "Size 1"
concept.class["hg20"] <- "B"
concept.desc["hg21"] <- "Size 3 or size 1"
concept.class["hg21"] <- "B"
concept.desc["hg22"] <- "Size 3 or size 2"
concept.class["hg22"] <- "B"
concept.desc["hg23"] <- "Size 2 or size 1"
concept.class["hg23"] <- "B"
concept.desc["hg24"] <- "Size 1 and blue"
concept.class["hg24"] <- "B"
concept.desc["hg25"] <- "Size 1 or blue"
concept.class["hg25"] <- "B"

concept.desc["hg26"] <- "One of largest or smallest"
concept.class["hg26"] <- "R"
concept.desc["hg27"] <- "Not one of largest or smallest"
concept.class["hg27"] <- "R"
concept.desc["hg28"] <- "One of the largest of its shape"
concept.class["hg28"] <- "R"
concept.desc["hg29"] <- "Unique largest"
concept.class["hg29"] <- "R"
concept.desc["hg30"] <- "Unique largest and blue"
concept.class["hg30"] <- "R"
concept.desc["hg31"] <- "Unique largest or blue"
concept.class["hg31"] <- "R"
concept.desc["hg32"] <- "One of the largest"
concept.class["hg32"] <- "R"
concept.desc["hg33"] <- "One of the largest and blue"
concept.class["hg33"] <- "R"
concept.desc["hg34"] <- "One of the largest or blue"
concept.class["hg34"] <- "R"
concept.desc["hg35"] <- "There exists a smaller object"
concept.class["hg35"] <- "R"
concept.desc["hg36"] <- "There exists a smaller blue object"
concept.class["hg36"] <- "R"
concept.desc["hg37"] <- "Same shape as a blue object"
concept.class["hg37"] <- "R"
concept.desc["hg38"] <- "Same shape as a [blue object or circle]"
concept.class["hg38"] <- "R"
concept.desc["hg39"] <- "Same shape as a [blue object or green object]"
concept.class["hg39"] <- "R"
concept.desc["hg40"] <- "[Same shape as a blue object] and not blue"
concept.class["hg40"] <- "R"
concept.desc["hg41"] <- "[Same shape as a blue object] or green"
concept.class["hg41"] <- "R"
concept.desc["hg42"] <- "[Same shape as a blue object] and green"
concept.class["hg42"] <- "R"
concept.desc["hg43"] <- "[Same shape as a blue object] and circle"
concept.class["hg43"] <- "R"
concept.desc["hg44"] <- "Same shape as the unique largest"
concept.class["hg44"] <- "R"
concept.desc["hg45"] <- "Same shape as one of the largest"
concept.class["hg45"] <- "R"
concept.desc["hg46"] <- "Same shape as one of the largest and blue"
concept.class["hg46"] <- "R"
concept.desc["hg47"] <- "Same shape as one of the largest or blue"
concept.class["hg47"] <- "R"
concept.desc["hg48"] <- "Same shape as the unique largest but not the largest"
concept.class["hg48"] <- "R"
concept.desc["hg49"] <- "Same shape as one of the largest but not one of the largest"
concept.class["hg49"] <- "R"
concept.desc["hg50"] <- "Unique blue object"
concept.class["hg50"] <- "R"
concept.desc["hg51"] <- "Unique circle"
concept.class["hg51"] <- "R"
concept.desc["hg52"] <- "The unique element and is [blue or green]"
concept.class["hg52"] <- "R"
concept.desc["hg53"] <- "The unique element and is [blue and circle]"
concept.class["hg53"] <- "R"
concept.desc["hg54"] <- "The unique element and is [blue or circle]"
concept.class["hg54"] <- "R"
concept.desc["hg55"] <- "Unique largest blue object"
concept.class["hg55"] <- "R"
concept.desc["hg56"] <- "Unique largest [blue or green] object"
concept.class["hg56"] <- "R"
concept.desc["hg57"] <- "Same shape as the unique largest blue object"
concept.class["hg57"] <- "R"
concept.desc["hg58"] <- "Same shape as one of the largest blue objects"
concept.class["hg58"] <- "R"
concept.desc["hg59"] <- "Exists another object with the same shape"
concept.class["hg59"] <- "R"
concept.desc["hg60"] <- "Exists another object with the same size"
concept.class["hg60"] <- "R"
concept.desc["hg61"] <- "[Exists another object with the same shape] or blue"
concept.class["hg61"] <- "R"
concept.desc["hg62"] <- "[Exists another object with the same shape] and blue"
concept.class["hg62"] <- "R"
concept.desc["hg63"] <- "Exists another object with the same color"
concept.class["hg63"] <- "R"
concept.desc["hg64"] <- "Does not exist another object with same shape"
concept.class["hg64"] <- "R"
concept.desc["hg65"] <- "Does not exist another object with same shape and color"
concept.class["hg65"] <- "R"
concept.desc["hg66"] <- "Every other object with the same shape is the same color"
concept.class["hg66"] <- "R"
concept.desc["hg67"] <- "[Every other object with the same shape is same color] or blue"
concept.class["hg67"] <- "R"
concept.desc["hg68"] <- "[Every other object with the same shape is same color] or circle"
concept.class["hg68"] <- "R"
concept.desc["hg69"] <- "*** Blue ***"
concept.class["hg69"] <- NA
concept.desc["hg70"] <- "*** Every other object with the same shape is the same color ***"
concept.class["hg70"] <- NA
concept.desc["hg71"] <- "Every other object with the same shape is not the same color"
concept.class["hg71"] <- "R"
concept.desc["hg72"] <- "There exists another blue object with the same shape"
concept.class["hg72"] <- "R"
concept.desc["hg73"] <- "Exists another object with same shape, and one with same color"
concept.class["hg73"] <- "R"
concept.desc["hg74"] <- "Exists another object with same shape, and a different one with same color "
concept.class["hg74"] <- "R"
concept.desc["hg75"] <- "Exists another object with same shape that has another with same color"
concept.class["hg75"] <- "R"
concept.desc["hg76"] <- "Shares a feature with every object"
concept.class["hg76"] <- "R"

concept.desc["hg77"] <- "Circle implies blue"
concept.class["hg77"] <- "B"
concept.desc["hg78"] <- "Blue implies circle"
concept.class["hg78"] <- "B"
concept.desc["hg79"] <- "[Not blue] implies circle"
concept.class["hg79"] <- "B"
concept.desc["hg80"] <- "[Not blue] implies [not circle]"
concept.class["hg80"] <- "B"
concept.desc["hg81"] <- "Blue implies size=1"
concept.class["hg81"] <- "B"
concept.desc["hg82"] <- "[Circle or triangle] implies blue"
concept.class["hg82"] <- "B"
concept.desc["hg83"] <- "[Circle and blue] or [triangle and green]"
concept.class["hg83"] <- "B"
concept.desc["hg84"] <- "Circle or blue or [triangle and green]"
concept.class["hg84"] <- "B"
concept.desc["hg85"] <- "Circle or [blue and triangle]"
concept.class["hg85"] <- "B"
concept.desc["hg86"] <- "Circle or [blue implies triangle]"
concept.class["hg86"] <- "B"
concept.desc["hg87"] <- "There exists a blue object of the same shape"
concept.class["hg87"] <- "R"
concept.desc["hg88"] <- "Same size as a circle"
concept.class["hg88"] <- "R"
concept.desc["hg89"] <- "Same shape as another object which is blue"
concept.class["hg89"] <- "R"
concept.desc["hg90"] <- "Same shape as another object which is [blue or green]"
concept.class["hg90"] <- "R"
concept.desc["hg91"] <- "Same shape as a [blue or green] object (potentially itself)"
concept.class["hg91"] <- "R"
concept.desc["hg92"] <- "*** The unique object that is blue ***"
concept.class["hg92"] <- NA
concept.desc["hg93"] <- "The unique object that is [blue or circle]"
concept.class["hg93"] <- "R"
concept.desc["hg94"] <- "The unique object that is [blue or green]"
concept.class["hg94"] <- "R"
concept.desc["hg95"] <- "The unique object that is [blue and circle]"
concept.class["hg95"] <- "R"
concept.desc["hg96"] <- "The unique object"
concept.class["hg96"] <- "R"
concept.desc["hg97"] <- "Same size as the unique blue object"
concept.class["hg97"] <- "R"
concept.desc["hg98"] <- "Unique smallest"
concept.class["hg98"] <- "R"
concept.desc["hg99"] <- "One of the smallest"
concept.class["hg99"] <- "R"
concept.desc["hg100"] <- "One of the smallest of its shape"
concept.class["hg100"] <- "R"
concept.desc["hg101"] <- "The unique smallest of its shape"
concept.class["hg101"] <- "R"
concept.desc["hg102"] <- "Exactly one other element is blue"
concept.class["hg102"] <- "R"
concept.desc["hg103"] <- "Exactly one element is blue"
concept.class["hg103"] <- "R"
concept.desc["hg104"] <- "Exactly one other element is the same color"
concept.class["hg104"] <- "R"
concept.desc["hg105"] <- "Same shape as exactly one blue object"
concept.class["hg105"] <- "R"
concept.desc["hg106"] <- "Same shape as exactly one other blue object"
concept.class["hg106"] <- "R"
concept.desc["hg107"] <- "*** Same shape as exactly one blue object ***"
concept.class["hg107"] <- NA
concept.desc["hg108"] <- "Every other object with the same shape is blue"
concept.class["hg108"] <- "R"
concept.desc["hg109"] <- "Every object with the same shape is blue"
concept.class["hg109"] <- "R"
concept.desc["hg110"] <- "All (>= 1) objects with the same shape are blue"
concept.class["hg110"] <- "R"
concept.desc["hg111"] <- "All (>= 1) objects with the same shape are the same color"
concept.class["hg111"] <- "R"
concept.desc["hg112"] <- "All (>= 1) other objects with the same shape are not the same color"
concept.class["hg112"] <- "R"

concepts <- names(concept.desc)



meanNA <- function(x) { mean(x, na.rm=TRUE) }

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# A standard way to load the subject data
load.subject.data <- function(print.summary=FALSE, remove.duplicate.concepts=TRUE) {

	d.raw <<- read.table(subject.data.file, header=T)
	
	if( remove.duplicate.concepts ) { # Get rid of those things we ran twice
		d.raw <<- d.raw[ !is.na(concept.class[as.character(d.raw$concept)]),]
# 		d.raw[ is.na(concept.class[d.raw$concept]), ] <- NA
	}

	d.raw$is.correct <- d.raw$response == d.raw$right.answer
	d.raw$conceptlist <- paste(d.raw$concept, d.raw$list, sep=".");
	
	# Transform to logit space?
	#concept.subj.means$mean <- logit(concept.subj.means$mean)
    
    keeperstats <- NULL # a table with keeper info
	
	d <- NULL	
	for(q in split(d.raw, d.raw$concept, drop=T)) {

		# number of responses per subject
		subject.table <- table(q$subject)
		subject.table <- names(subject.table[subject.table > 10]) # this is responses, so lets use more
	
		q <- q[is.element(q$subject, subject.table),]

		# The means for each subject in each concept,list
		subj.means <- aggregate(q$is.correct, by=list(q$subject), function(x){mean(x,na.rm=T)})
		names(subj.means) <- c("subj", "mean")
		
		m <- mean(subj.means$mean, na.rm=T ) # or ovrall mean? Hmm how could we do sds then? This is not great for partial data
		s <- sd( subj.means$mean, na.rm=T )

		keepers <- as.character(subj.means[ (subj.means$mean - m) / s > -2,]$subj) # 2 sds worse than mean are kicked out
		
		keeperstats <- rbind(keeperstats, data.frame(keep=length(keepers), outof=nrow(subj.means), concept=q$concept[1]))
		
		d <- rbind(d, q[is.element(q$subject, keepers),])

	}
	
	with(keeperstats, 
        print(c( sum(keep), sum(outof), mean(keep/outof), sd(keep/outof))))
		
		
	# summarize the results after we read them?
	if(print.summary) {
		# hmm not doing this anymore
	}	
		
		
	return(d)
}
	
load.ag.subject.data <- function() {
	d <<- load.subject.data(print.summary=FALSE)
	d.ag <- aggregate.binomial(d$response, by=list(d$concept, d$list, d$set.number, d$response.number, d$right.answer), stats=F)
	names(d.ag)[1:5] <- c("concept", "list", "set.number", "response.number", "right.answer")
	d.ag <- sort(d.ag, by= ~ concept + list + set.number + response.number + right.answer)
	d.ag$p.correct <- ifelse(d.ag$right.answer, d.ag$p, 1-d.ag$p)
	
	return(d.ag)
}

Rsq <- function(a,b, method="pearson") {
	x <- cor.test(a,b, method=method)
	return(x$estimat * x$estimate)
}

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# # # Compute the stats we care about for each model

compute.model.stats <- function(md, d.ag) { # give a model directory and subject data aggregated

	print(paste(md, "/across-samples.txt", sep=""))
		
	m <- try(read.table(paste(md, "/across-samples.txt", sep=""), header=F))
	
	MAP <- NA
	MAP.first <- NA # do this on the second half only, as a quick convergence check
	nr <- NA
	cor <- NA
	if( class(m) != "try-error") {
		
		infs <- (m[,1]=="-inf.0") | is.na(m[,1])
		m[infs,1] <- -Inf
		m[,1] <- as.numeric(as.character(m[,1])) 

		MAP <- max(m[,1], na.rm=T)
		MAP.first <- max(m[1:(nrow(m)/2),1], na.rm=T)
		
		nr <- nrow(m)
		datapoints <- max(m[,2], na.rm=T)
		fp <- max(m[,3], na.rm=T) # free params
	}
	
	md2 <- gsub(".+/CONCEPT", "CONCEPT", md, perl=T)
	p2h <- params2hash(md2)	
	
	# also let's load up its predictives and get the correlation
	rsqs <- NA
	rsq.splithalf <- NA; 
	concept.mean.difficulty <- NULL;
	all.ll <- 0
	ho.ll <- 0
	last.ho.ll <- NULL # this is set every time we call compute.model.stats
	all.ho.ll <- NULL
	for(pf in list.files(paste(md, "/predictive", sep=""))) {
		
		d.pf <- read.table(paste(md, "/predictive/", pf, sep=""), header=F)
		param.pf <- params2hash(pf)
		pred <- t( d.pf[1,-c(1,2)])
		q <- d.ag[d.ag$concept == param.pf["CONCEPT"] & d.ag$list == param.pf["LIST"],]
		q <- merge(q, ho.key) # merge in the held out key
		q <- sort(q, by= ~ set.number + response.number + right.answer)
		if(nrow(q) == nrow(pred)) {
			
			# compute the Rsq -- now only on held-out data!
			#rsqs <- c(rsqs, Rsq( q$p, pred) )
# 			print(q)
			if(nrow(q[q$is.held.out,]) > 0) {
				rsqs <- c(rsqs, Rsq( q[q$is.held.out,]$p, pred[q$is.held.out,]) )
			}
			
			# Now do a split half. We'll do this by splitting the data in half
			# we do this by flipping a coin for each T response to determine which it came from
			q1 <- data.frame( x=rbinom(rep(1, nrow(q)), size=q$x, p=0.5), n=floor(q$n/2))
			q1$p <- q1$x / q1$n
			q2 <- data.frame( x=q$x-q1$x, n=q$n-q1$n)
			q2$p <- q2$x / q2$n
			
			rsq.splithalf <- c(rsq.splithalf, Rsq(q1$p, q2$p))

			# add up the ho ll
			ho.ll <- ho.ll + sum(  q$is.held.out*(log(pred)*q$x + log(1.0-pred)*(q$n-q$x) ) )
			all.ll <- all.ll + sum(  (log(pred)*q$x + log(1.0-pred)*(q$n-q$x) ))
			last.ho.ll <- c(last.ho.ll, sum(  q$is.held.out*(log(pred)*q$x + log(1.0-pred)*(q$n-q$x) )))
			all.ho.ll <- c(all.ho.ll, q$is.held.out*(log(pred)*q$x + log(1.0-pred)*(q$n-q$x) )) # not aggregated by concept

			# now compute the overall accuracy in this concept
			# for getting the correlation overconcepts of mean accuracy
			concept.mean.difficulty <- rbind(concept.mean.difficulty,
  					                 data.frame( human=mean(ifelse(q$right.answer,q$p,1-q$p)),
								     model=mean(ifelse(q$right.answer,pred,1-pred))))
		}	
		else { print(paste("warning: concepts do notline up!", pf)) }

	}	

# 	last.ho.ll <<- ho.ll
# 	(1-q$is.held.out) * (log(pred)*q$x + log(1.0-pred)*(q$n-q$x) )

	# do a plot of this model's R^2s
# 	bitmap( paste("modelplots/",md,"-Rsq.png",sep=""), height=2,width=4, res=200)
# 	h <- hist(rsqs, breaks=seq(-1,1,0.1), freq=F, col=1, main="", xlab="Correlation", ylab="",cex.axis=2, cex.lab=2, font=2)
# 	abline(v=0)
# 	dev.off()
	 ## Spearman-Brown prophecy formula: we'll get the mean R^2
	full.splithalf <- mean( (2*sqrt(rsq.splithalf) / (1+sqrt(rsq.splithalf)))^2, na.rm=T)
	list(last.ho.ll,  ### TODO: WE DID THIS SO WE COULD HAVE ACCESS TO THE HELDOUT LL
	data.frame(     CONCEPT=p2h["CONCEPT"],
			LANGUAGE=p2h["LANGUAGE"],
			INHYT=p2h["INHYT"],
			MODEL=p2h["MODEL"],
			nrow=nr,
			MAP=MAP,
			MAP.first=MAP.first,
			BIC=( -2*MAP + fp*log(datapoints)),
			HO.LL=ho.ll,
			ALL.LL=all.ll,
			num.data=datapoints,
			free.params=fp,
			correlation.mean=mean(rsqs, na.rm=TRUE),
			correlation.max=max(rsqs, na.rm=TRUE),
			correlation.min=min(rsqs, na.rm=TRUE),
			splithalf=mean(rsq.splithalf, na.rm=TRUE),
			full.splithalf=full.splithalf,
			across.concept.correlation=Rsq(concept.mean.difficulty$human,
							concept.mean.difficulty$model)
				  ),
	all.ho.ll)
}
	