(import (rnrs files (6)))

;; SRFI Notes:
;; We have to change all the "compat" stuff in srfi in order to make it work with vicare -- just copy the ikarus file
;; alsow e had to change 13 to not export string-hash and string-hash-ci, since these are already provided by hashtables
;; get srfis from here: https://code.launchpad.net/~scheme-libraries-team/scheme-libraries/srfi

;; NOTES:
;; This will break if the data it gets is not exactly in the right format. Not much debugging etc. 

;; It also appears we need a "vicare" folder containing "foreign." This should be from vicare's library

;(load "/home/piantado/Desktop/mit/Libraries/LOT-lib/LOT-lib.scm")
(load "/data/scratch/piantado/Libraries/LOT-lib/LOT-lib.scm")

;(define/log! OUT-PREFIX "./run/CONCEPT_ALL__LANGUAGE_NA/") ;; a directory which will be created, for our output files
(define/log! OUT-PREFIX "./run/aaa-testrun/") ;; a directory which will be created, for our output files

(define/log! IN-TOP "25")
(define/log! IN-HYPOTHESES "mcmc-hypotheses/") ;; where the initializing hypotheses live
(define/log! IN-HYPOTHESIS-TYPE "RAW") ; "RAW" or "NONCRAZY"

(define/log! MCMC-within-steps 10)
(define/log! MCMC-within-skip  0)

(define/log! MCMC-across-steps 10)
(define/log! MCMC-across-skip  0)

(define/log! MCMC-grammar-steps 10)
(define/log! MCMC-grammar-skip  0)

(define/log! GRAMMAR-PROPOSAL-SCALE 1.0) 
(define/log! GRAMMAR-PROPOSAL-SCALE-STEP-AT 25) ;; after this many *outer-loops*, we change this 

(define/log! TOTAL-OUTER-LOOPS 100)

(define/log! CONCEPTS "ALL");"hg01,hg02,hg03,hg04"); 

(define/log! DATA-AMOUNTS 24); IMMEDIATELY converted to a list below 0.. this
(define/log! REFRESH-DATA-AMOUNTS 24); IMMEDIATELY converted to a list below 
(define/log! REFRESH-MCMC-STEPS 10000) ;; 1000
(define/log! REFRESH-EVERY 5) ;; was 25 ;; run the across/within/grammar loops this many times before we refresh
(define/log! REFRESH-TOP-N 25) 
(define/log! REFRESH-TEMPERATURE 1.0)
(define/log! DO-REFRESH 1) ;; 1 = do a refresh step
(define/log! DO-GRAMMAR-PRIOR 1)
(define/log! DO-GRAMMAR-INFERENCE 1) ;; if 0, we don't do inference over the grammar. This makes the "flat" versions

(define/log! LISTS "L1,L2")
;; NOTE IF YOU DO NOT HOLD OUT AN ENTIRE LIST, FIX FITTING-LISTS!!!
(define/log! FITTING-LISTS '("L1")) ;; this is what is used for computing the likelihood of human responses (in case we hold out one list). If you hold out one list, put the non-held-out-one here

;; these parameterize the PCFG prior
(define/log! GAMMA-k 2.0)
(define/log! GAMMA-theta 1.0)

(define/log! LOAD-LANGUAGE-FILE null) ;; if non-null we load this, presumed to contain language files

(define/log! LANGUAGE "Language-LAM-QEF-EOQ-CRD-Q2O-SMC") ;; Language-Base, LangChanging a program in ENIAC took at least two days. ENIAC was the first supercomputer to atChanging a program in ENIAC took at least two days. ENIAC was the first supercomputer to atuage-Boolean, Language-No-Quantifiers

(define/log! MODEL "./models/parameterized-RR.scm")

;; These are needed in HSFL-General, but have to be defined here so that we can parse them on the command line
(define/log! IN-HUMAN-RESPONSES "./Data-Scheme-HELD-OUT.txt") 
(define/log! CONCEPT-DIRECTORY "../concepts/") ;; where the data p<CONCEPT>.L<List>.txt lives
(define/log! QUANTIFIER-FORMAT 0) ; 1 = we are doing quantifiers, else set functions (set->subset)

(define make-model null)

;(displayn (string-contains MODEL "parameterized-PCFG"))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Set up input and log it
(parse-command-line)

;; NOTE: For now, this must start at 0 (no data) because of how we compute the mapping of responses to C blocks.
(set! REFRESH-DATA-AMOUNTS (seq 0 REFRESH-DATA-AMOUNTS 1)) ;; Change this to a list for below. Must start at 0
(set! DATA-AMOUNTS (seq 0 DATA-AMOUNTS 1)) 

(load "HSFL-General.scm") ;; shared parts of SFL. We have ot load this after command line so we cna load different concepts, etc

;; Fix IN-TOP to be  astring
(if (string? IN-TOP) (set! IN-TOP (string->number IN-TOP)))

(if (not (null? LOAD-LANGUAGE-FILE)) (load LOAD-LANGUAGE-FILE))

(define SFL-grammar (eval (string->symbol LANGUAGE) (interaction-environment)))

;; We can specify CONCEPTS in a few different formats. Here we convert them 
;; all to a list of strings
(cond ((null? CONCEPTS) (set! CONCEPTS ALL-CONCEPTS))
      ((list? CONCEPTS) #t );; just do nothing
      ((string=? CONCEPTS "BOOLEAN") (set! CONCEPTS BOOLEAN-CONCEPTS))
      ((string=? CONCEPTS "ALL")     (set! CONCEPTS ALL-CONCEPTS))
      ( #t (set! CONCEPTS (str-split CONCEPTS #\,))) ;; else a comma separated list
      )

(set! LISTS (str-split LISTS #\,)) ;(edisplayn LISTS)



;; open some output files
(define RESUME-PATH (string-append OUT-PREFIX "resume"))
(define LOG-OUT-FILE (string-append OUT-PREFIX "log.txt"))
(define GRAMMAR-SAMPLE-OUT-FILE (string-append OUT-PREFIX "grammar-samples.txt"))
(define ACROSS-SAMPLE-OUT-FILE (string-append OUT-PREFIX "across-samples.txt")) ;; for across concept parameters
(define WITHIN-PREFIX (string-append OUT-PREFIX "within/"))
(define PREDICTIVE-PREFIX (string-append OUT-PREFIX "predictive/"))
(define ENTROPY-PREFIX (string-append OUT-PREFIX "entropy/"))

;; Initialize our output files
(if (not (file-exists? OUT-PREFIX))
    (begin (set! :resume-flag: #f)
           (mkdir OUT-PREFIX)
           (mkdir WITHIN-PREFIX)
           (mkdir RESUME-PATH)
           (mkdir PREDICTIVE-PREFIX)
           (mkdir ENTROPY-PREFIX)))
(cat-logging-information LOG-OUT-FILE) 
(cat-logging-information GRAMMAR-SAMPLE-OUT-FILE) 
(cat-logging-information ACROSS-SAMPLE-OUT-FILE) 

;; Randomize the RNG
;(random-source-randomize! default-random-source) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Locally handy functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define cl2model (make-equal-hashtable))

(define (model c l) 
  (hashtable-ref cl2model (list c l) null)) ;; a nice wrapper for each model

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Include the right model type, which defines the right "class" for getting mdoel results
;;;; This model also defines the "across-parameters" and their samplers, etc. 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(load MODEL)

(set-model) ;; This sets all the model parameters and make-model to the correct things for what was loaded just above

;; And set up the model so we can read its params below
(for c in CONCEPTS
  (for l in LISTS
    (hashtable-set! cl2model (list c l) (make-model))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Some misc things to compute
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Initialize the concept data
(tabbycatn LOG-OUT-FILE "Reading in the concept data files.")
(define-concept-data)

;; compute our total number of data points. This is how many
;; points our specific model run was on. 
(define my-total-number-of-points 0)
(for c in CONCEPTS
  (for l in LISTS
    (set! my-total-number-of-points (+ my-total-number-of-points
                                       (hashtable-ref cl2data-N (list c l) 0)))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Parameters and grammar -- for doing grammar and parameter inference
;; These must be defined before resuming
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define within-parameters (make-equal-hashtable) )
(for c in CONCEPTS
  (for l in LISTS
    (hashtable-set! within-parameters (list c l) ( (model c l) 'get-initial-p))))

;;set up the grammar prior
(define grammar-parameter (SFL-grammar 'get-flat-count-vector 1.0))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Here are variables that would be resumed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define loops-run-so-far 0)
(define best-so-far -inf.0) ;; hash each concept to the best value so far

;; And do the hypotheses here too
(tabbycatn LOG-OUT-FILE "Initializing hypotheses.")
(define cl2allhyps (make-equal-hashtable)) ;;; a list of hypotheses (PCFG-NODEs) for each initializing concept
(define cl2initialhyps (make-equal-hashtable)) ;; save the initial hypotheses for when we refresh

(for c in CONCEPTS
  (for l in LISTS
    (tabbycatn LOG-OUT-FILE "Reading data files " c " " l )
    (let ((hyplist (load-hypothesis-list IN-HYPOTHESES LANGUAGE c l IN-HYPOTHESIS-TYPE IN-TOP)))
      (hashtable-set! cl2allhyps (list c l) hyplist) ;; these are the ones 
      (hashtable-set! cl2initialhyps (list c l) hyplist))))

;; We must resume here, so everything has to be defined previously
(resume-here! RESUME-PATH)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Actual script
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Initialize the hypotheses
;; a list of hypotheses for each (concept list). These are read by taking the top of an MCMC run
;; and are used to initialize the top N for each amount of data
(tabbycatn LOG-OUT-FILE "Loading model data.")


(for c in CONCEPTS
  (for l in LISTS
    
    ;(edisplayn (map first (hashtable-ref cl2data (list c l) null)))
    ( (model c l) 'model-set-correct!   (apply append (map first (hashtable-ref cl2data (list c l) null))))
    
    ; (displayn (hashtable-ref cl2which-item (list c l) null))
    ( (model c l) 'model-set-which-item! (hashtable-ref cl2which-item (list c l) null))
    
    ;; And load the hypotheses
    (for h in (hashtable-ref cl2allhyps (list c l) null)
      ( (model c l) 'model-push-hypothesis! 
                    h 
                    (apply append (get-function-response h (map second 
                                                                (hashtable-ref cl2data (list c l) null))))))
    
    ;; and set the model data      
    ( (model c l) 'model-set-data! (hashtable-ref cl2data (list c l) null))
    
    ))


(tabbycatn LOG-OUT-FILE "Initializing model.")

;; This sets up the model once we've 
(for c in CONCEPTS
  (for l in LISTS
    ( (model c l) 'initialize-model)))


(tabbycatn LOG-OUT-FILE "Done initializing model.")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Run MCMC to refresh model c, l according to our grammar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;; this runs MCMC once for the prior, and then adds those, isntead of running once for each
;; data point. this is 100*2*25 times faster. 
(define (quick-refresh-model)
  (define initial-H (SFL-grammar 'generate 'FUNCTION MAX-DEPTH))
  (define topN (make-TopN REFRESH-TOP-N PCFG-NODE-hash PCFG-NODE-eqv?))
  
  (metropolis-hastings-simple! (make-MH-STATE initial-H null null)
                               REFRESH-MCMC-STEPS
                               0
                               REFRESH-TEMPERATURE
                               (lambda (h) ( (model (first CONCEPTS) (first LISTS))  ;; anyone's prior should work
                                             'model-compute-prior
                                             (hashtable-ref within-parameters (list (first CONCEPTS) (first LISTS)) null)
                                             grammar-parameter
                                             across-parameters
                                             h)) 
                               (lambda (D H) 0.0) ;; only sample from the prior
                               null
                               (lambda (h)  (SFL-grammar 'resample h (+ MAX-DEPTH 2)))
                               (lambda (mhs)
                                 (if (> (MH-STATE-posterior mhs) -inf.0)
                                     (topN 'potentially-insert! (MH-STATE-hypothesis mhs) (MH-STATE-posterior mhs))))
                               PCFG-NODE-eqv?
                               null ;;a hash to keep track of accept/reject. Can be null
                               )
  
  (let ((tH (topN 'extract-all-sorted!)))
    
    (for c in CONCEPTS
      (for l in LISTS
        
        ;; store the hypotheses for each concept
        (define hyp (make-equal-hashtable))
        (for h in (hashtable-ref cl2initialhyps (list c l) null)
          (hashtable-set! hyp h 1))
        
        ;; Save the hypotheses in the top N
        (map (lambda (h) (hashtable-set! hyp h 1)) 
             tH)
        
        ;; Clear hypotheses in the model
        ( (model c l) 'clear-hypotheses!)
        
        ;; save these
        (hashtable-set! cl2allhyps 
                        (list c l) 
                        (vector->list (hashtable-keys hyp)))
        
        ; Now add them back to the model
        ; NOTE: This is inefficient because we recompute PCFG-counts, but lets go with it for now
        (for h in (vector->list (hashtable-keys hyp))
          ( (model c l) 'model-push-hypothesis! 
                        h 
                        (apply append (get-function-response h (map second 
                                                                    (hashtable-ref cl2data (list c l) null)))))))))
  
  )
;
;
;
;;; NOTE: This computes using SFL-grammar. 
;;; NOTE: This should only be called with PCFG-based models (flat-PCFG, flat-RR, parameterized-PCFg, parameterized-RR)
;(define (refresh-model c l)
;  
;  (define hyp (make-equal-hashtable)) ;; this stores our current set of hypothese, to be saved in allhyps in order to resume correctly
;  (for h in (hashtable-ref cl2initialhyps (list c l) null)
;    (hashtable-set! hyp h 1))
;  
;  (for di in REFRESH-DATA-AMOUNTS
;    (define D (first-n (hashtable-ref cl2data (list c l) null)
;                       di ))
;    (define initial-H (SFL-grammar 'generate 'FUNCTION MAX-DEPTH))
;    (define topN (make-TopN REFRESH-TOP-N PCFG-NODE-hash PCFG-NODE-eqv?))
;    
;    (tabbycatn LOG-OUT-FILE "MCMC " c " " l  " " di)
;    
;    (metropolis-hastings-simple! (make-MH-STATE initial-H null null)
;                                 REFRESH-MCMC-STEPS
;                                 0
;                                 REFRESH-TEMPERATURE
;                                 (lambda (h) ( (model c l)  'model-compute-prior
;                                                            (hashtable-ref within-parameters (list c l) null)
;                                                            grammar-parameter
;                                                            across-parameters
;                                                            h)) 
;                                 (lambda (D H) ( (model c l) 'model-compute-likelihood   ;; a function of data and hypothesis
;                                                             (hashtable-ref within-parameters (list c l) null)
;                                                             grammar-parameter
;                                                             across-parameters
;                                                             D H))
;                                 D
;                                 (lambda (h)  (SFL-grammar 'resample h (+ MAX-DEPTH 2)))
;                                 (lambda (mhs)
;                                   (topN 'potentially-insert! (MH-STATE-hypothesis mhs) (MH-STATE-posterior mhs)))
;                                 PCFG-NODE-eqv?
;                                 null ;;a hash to keep track of accept/reject. Can be null
;                                 )
;    
;    ;; Save the hypotheses in the top N
;    (map (lambda (h) (hashtable-set! hyp h 1))
;         (topN 'extract-all-sorted!)))
;  
;  ;; Clear hypotheses in the model
;  ( (model c l) 'clear-hypotheses!)
;  
;  ;; save these
;  (hashtable-set! cl2allhyps 
;                  (list c l) 
;                  (vector->list (hashtable-keys hyp)))
;  
;  ; Now add them back to the model
;  ; NOTE: This is inefficient because we recompute PCFG-counts, but lets go with it for now
;  (for h in (vector->list (hashtable-keys hyp))
;    ( (model c l) 'model-push-hypothesis! 
;                  h 
;                  (apply append (get-function-response h (map second 
;                                                              (hashtable-ref cl2data (list c l) null))))))
;  null)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Scorers -- for doing grammar and parameter inference
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; density of a gamma distribution
(define (log-gamma-density k theta x)
  (+ (* (- k 1) (log x))
     (- (/ x theta))
     (* (- k) (log theta))
     (- (gsl-lngamma k))))

;; uses GAMMA-k and GAMMA-theta defined above to compute the log prior
;; of the grammar parameters gp
(define (compute-grammar-parameters-prior grammar-parameter)
  (apply + (map (lambda (ntpart) 
                  (apply + (map (lambda (x) (if (> x 0.0) (log-gamma-density GAMMA-k GAMMA-theta x) 0.0))
                                ntpart)))
                grammar-parameter)))


;; For a parameter vector, compute the score of all human data
;; TODO; This is not an intuitive name for this function
(define (compute-total-human-score-within gp ap)
  (define total-score 0.0)
  
  ; (displayn gp)
  
  ;; include a gamma prior over the grammar
  (if (= DO-GRAMMAR-PRIOR 1)
      (set! total-score (+ total-score (compute-grammar-parameters-prior gp))))
  
  (for c in CONCEPTS
    (for l in FITTING-LISTS
      ;(edisplayn c l)
      ; (edisplayn c "\t" l "\t" (length (apply append (map first (hashtable-ref cl2data (list c l) null)))))
      ;(edisplayn c "\t" l "\t" (hashtable-ref cl2correct (list c l) null))
      ;(edisplayn c "\t" l "\t" (hashtable-ref cl2which-item (list c l) null))
      ;(edisplayn c "\t" l "\t" (hashtable-ref cl2human-true (list c l) null))
      ;(edisplayn c "\t" l "\t" (hashtable-ref cl2human-false (list c l) null))
      ; (edisplayn c "\t" l "\t" (length (apply append (hashtable-ref cl2correct (list c l) null))))
      
      
      (set! total-score (+ total-score 
                           (compute-human-score (hashtable-ref within-parameters (list c l) null)
                                                gp 
                                                c 
                                                l
                                                ap)))))
  
  (if (and (real? total-score) (> total-score -inf.0) )
      total-score
      -inf.0 ;; must be nan.. hmm TOOD: Check this!
      ))

;; get the human score on c and l
(define (compute-human-score p gp c l ap)
  (let* ((mpred  ( (model c l) 'model-prediction p gp ap))
         ;(xxn (displayn mpred))
         (total-score (+ (apply + (map (lambda (h m) 
                                         (if (> h 0) (* h (log m)) 0)) 
                                       (hashtable-ref cl2human-true (list c l) null)
                                       mpred))
                         (apply + (map (lambda (h m) (if (> h 0) (* h (log (- 1.0 m))) 0))
                                       (hashtable-ref cl2human-false (list c l) null)
                                       mpred)))))
    ;(edisplayn "HERE\t" total-score mpred)
    (if (and (real? total-score) (> total-score -inf.0) )
        total-score
        -inf.0 ;; must be nan.. hmm TOOD: Check this!
        )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Proposers -- for doing grammar and parameter inference
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; proposer for across parameters
(define (propose-across p)
  (if (> (vector-length p) 0) ;; if there are any fit here, else just return p with 0.0
      (let* ((i (random-between 0 (- (vector-length p) 1)))
             (v (vector-copy p))
             (prop ( (vector-ref across-proposers i) (vector-ref p i))))
        (vector-set! v i (second prop))
        (list (first prop) v))
      (list 0.0 p)))

;; proposer for within parameters
(define within-proposer-functions ((model (car CONCEPTS) (car LISTS)) 'get-proposers)) ;; Hopefully the same for all models here!
;(edisplayn within-proposer-functions)


(define (propose-within p)
  
  ; (edisplayn "STARTING PROPOSAL: " p)
  (if (> (vector-length p) 0)
      (let* ((i (random-between 0 (- (vector-length p) 1)))
             (v (vector-copy p))
             (prop ( (vector-ref within-proposer-functions i) (vector-ref p i))))
        (vector-set! v i (second prop))
        (list (first prop) v))
      (list 0.0 p)))

; (edisplayn "!!_-HERE-_!!")
; (list 0.0 p))

;; propose to the grammar, giving back a new grammar parameter
;; TODO: Make this not change the first element when not in possible-bv-nonterminals
;(define (proposer-grammar gp)
;  (define lp 0.0)
;  (define newgp  (map (lambda (gpnt) ;; for each nonterminal
;                        (if (< (random-real) 0.25) ;; do proposals to some set of these
;                            (map (lambda (x) 
;                                   (if (> x 0.0) ;; leave zeros unchanged since they must be bound variables we don't want to change
;                                       (let ((propp (positive-normal-proposal x (* GRAMMAR-PROPOSAL-SCALE 0.1))))
;                                         (set! lp (+ lp (first propp)))
;                                         (second propp))
;                                       0.0)) 
;                                 gpnt)
;                            gpnt))
;                      gp))
;  
;  (list lp newgp))
(define (proposer-grammar gp)
  (define lp 0.0)
  (define newgp  
    (map (lambda (gpnt) ;; for each nonterminal
           (let ((i (random-between 1 (+ 1 (length gpnt)))))
             ; (edisplayn i)
             (map (lambda (x) 
                    (set! i (- i 1))
                    (if (> x 0.0) ;; leave zeros unchanged: they are bound variables we don't want to change
                        (if (= i 0)
                            (let ((propp (positive-normal-proposal x (* GRAMMAR-PROPOSAL-SCALE 0.1))))
                              (set! lp (+ lp (first propp)))
                              (second propp))
                            x)
                        0.0)) 
                  gpnt)))
         gp))
  
  ; (edisplayn newgp)
  
  (list lp newgp))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Samplers -- for doing grammar and parameter inference
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; call this on each sample. 
;; It outputs the model predictive and the 
;; trace of the mcmc run
(define (sample-within mhs c l)  
  (tabbycatn (string-append WITHIN-PREFIX "within__CONCEPT_" c "__LIST_" l ".txt")
             c
             l
             (MH-STATE-posterior mhs)
             (hashtable-ref cl2data-N (list c l) 0)
             (vector->list (MH-STATE-hypothesis mhs)))  
  )


;; Sample across-concept variables (alpha, prior-temp, baserate)
(define (sample-across mhs)
  
  (tabbycatn ACROSS-SAMPLE-OUT-FILE
             (MH-STATE-posterior mhs) 
             my-total-number-of-points
             free-parameter-count
             (vector->list (MH-STATE-hypothesis mhs)))
  
  ;; And here we compute if we're the best (not within, since that does the wrong thing)
  ;(recheck-MAP) ;; NOTE: this has been moved to only occur after grammar refreshing. 
  )

;; this takes a MHS and checks if it is the MAP and if so, it 
(define (recheck-MAP)
  (let ((posterior (compute-total-human-score-within grammar-parameter across-parameters)))
    (if (> posterior best-so-far)
        (begin
          (set! best-so-far posterior) ;; savethis
          
          (for c in CONCEPTS
            (for l in LISTS
              (let ((predictive-name (string-append PREDICTIVE-PREFIX "predictive__CONCEPT_" c "__LIST_" l ".txt"))
                    (mpred ( (model c l) 'model-prediction 
                                         (hashtable-ref within-parameters (list c l) null) 
                                         grammar-parameter
                                         across-parameters))
                    ;(entropy-name (string-append ENTROPY-PREFIX "entropy__CONCEPT_" c "__LIST_" l ".txt")) ;; compute entropy
                    ;(mH ( (model c l) 'model-entropy
                    ;                  (hashtable-ref within-parameters (list c l) null) 
                    ;                  grammar-parameter
                    ;                  across-parameters))
                    )
                
                (if (file-exists? predictive-name) (delete-file predictive-name))
                (tabbycatn predictive-name c l mpred)
                
                ; (if (file-exists? entropy-name) (delete-file entropy-name))
                ; (tabbycatn entropy-name c l mH)
                
                )))))))

;; A sampler for the grammar
(define (sampler-grammar mhs-g) 
  (tabbycatn GRAMMAR-SAMPLE-OUT-FILE
             (MH-STATE-posterior mhs-g)
             my-total-number-of-points 
             (map (lambda (nt) (let ((s (sum nt))
                                     (isPCFG (string-contains MODEL "parameterized-PCFG")))
                                 (map (lambda (x) (roundto3 (if isPCFG 
                                                                (/ x s)
                                                                x)))
                                      nt)))
                  (MH-STATE-hypothesis mhs-g))))


;; Initialize the grammar MCMC output
(tabbycatn GRAMMAR-SAMPLE-OUT-FILE
           "posterior"
           "number.of.points"
           (SFL-grammar 'get-rule-strings))

(define free-parameter-count 
  (+ (if (= DO-GRAMMAR-INFERENCE 1) ;; then we have a bunch of grammar parameters
         (+ (apply + (map (lambda (ntpart) (apply + (map (lambda (x) (if (> x 0.0) 1 0)) ntpart)))
                          grammar-parameter))
            (if (string-contains MODEL "parameterized-PCFG") 
                (- (length grammar-parameter))
                0) ;; one fewer for each nt since they are normalized to 1
            )
         0)
     (vector-length across-parameters) ;; across params
     (apply + (map (lambda (c) ;; within params
                     (apply + (map (lambda (l) (vector-length (hashtable-ref within-parameters (list c l) null)))
                                   LISTS)))
                   CONCEPTS))))


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;; Main MH loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;; To keep us from recomputing the posterior, we will have one MH-state where we just change the hypothesis
;; and leave the posterior, etc alone. 

(tabbycatn LOG-OUT-FILE "Starting MCMC.")

(let mcmc-dual-loop ((mcmc-dual-loop-i loops-run-so-far))
  
  ;; + + + + + + + + + + + + + + + + + + + + + + + + + + +  
  (if (> (vector-length within-proposer-functions) 0) ;; if this is null, we don't do within proposals
      (for c in CONCEPTS
        (for l in LISTS
          
          (let ((mhs (metropolis-hastings-simple! (make-MH-STATE (hashtable-ref within-parameters (list c l) null) 
                                                                 null ;; nulls make it recomputed 
                                                                 null)
                                                  MCMC-within-steps
                                                  MCMC-within-skip ; skip this many
                                                  1.0 ;; temperature
                                                  (lambda args 0.0) ;; our prior on parameters
                                                  (lambda (D p) (compute-human-score p 
                                                                                     grammar-parameter 
                                                                                     c 
                                                                                     l  
                                                                                     across-parameters))
                                                  null ;; no data
                                                  propose-within
                                                  (lambda (mhs) (sample-within mhs c l)) ;; sampler
                                                  equal?  
                                                  null
                                                  )))
            ;; Save the best here if we find it
            (hashtable-set! within-parameters (list c l) (MH-STATE-hypothesis mhs))
            
            ;; output the predictive file
            ;; you take the last line for each concep tand list, and thats the best so far
            ))))
  (save-variable! RESUME-PATH 'within-parameters 'equal-hashtable)   ;; ~ ~ ~ ~ ~
  (save-variable! RESUME-PATH 'best-so-far)
  
  ;(edisplayn "!!HERE!!")
  ;; + + + + + + + + + + + + + + + + + + + + + + + + + + +
  ;; And MCMC for the across parameters
  
  ; For simplicity, we will always call this no matter what (even if there are no across parameters)
  ;; in order to always have the right number of lines in output
  (time (set! across-parameters 
        (MH-STATE-hypothesis  (metropolis-hastings-simple! (make-MH-STATE across-parameters  null null)                                   
                                                           MCMC-across-steps
                                                           MCMC-across-skip ; skip this many
                                                           1.0 ;; temperature
                                                           (lambda args 0.0) ;; our prior on parameters
                                                           (lambda (D ap) 
                                                             (compute-total-human-score-within grammar-parameter ap)) 
                                                           null ;; no data
                                                           propose-across
                                                           sample-across
                                                           equal? 
                                                           null;'() ;;a hash to keep track of accept/reject. Can be null
                                                           ))))
      
      ; (edisplayn "**HERE**")
  
  (save-variable! RESUME-PATH 'across-parameters) ;; ~ ~ ~ ~ ~
  
  
  ;; + + + + + + + + + + + + + + + + + + + + + + + + + + +
  ;; Now MCMC over the grammar
  (if (= DO-GRAMMAR-INFERENCE 1) 
      (begin (set! grammar-parameter 
                   (MH-STATE-hypothesis  (metropolis-hastings-simple! (make-MH-STATE grammar-parameter  null null)                                   
                                                                      MCMC-grammar-steps
                                                                      MCMC-grammar-skip ; skip this many
                                                                      1.0 ;; temperature
                                                                      (lambda args 0.0) ;; our prior on parameters
                                                                      (lambda (D gp) 
                                                                        (compute-total-human-score-within gp across-parameters)) 
                                                                      null ;; no data
                                                                      proposer-grammar
                                                                      sampler-grammar
                                                                      equal? 
                                                                      null;'() ;;a hash to keep track of accept/reject. Can be null
                                                                      )))
             (save-variable! RESUME-PATH 'grammar-parameter)
             ))
  
  ;; + + + + + + + + + + + + + + + + + + + + + + + + + + +
  ;; And call refresh (re-do MCMC with the new grammar) whenever we should!
  (if (and (= DO-GRAMMAR-INFERENCE 1) 
           (= DO-REFRESH 1))
      (if (= (modulo (+ 1 mcmc-dual-loop-i) REFRESH-EVERY) 0) ;; refresh this often
          (begin (quick-refresh-model)
                 (save-variable! RESUME-PATH 'cl2allhyps 'equal-hashtable )        ;; ~ ~ ~ ~ ~
                 (recheck-MAP) ;; we only check map here
                 ))
      (begin (recheck-MAP)))
  
  ;; + + + + + + + + + + + + + + + + + + + + + + + + + + +
  ;; move this thing down after we've run for a bit
  (if (= mcmc-dual-loop-i GRAMMAR-PROPOSAL-SCALE-STEP-AT)
      (set! GRAMMAR-PROPOSAL-SCALE (/ GRAMMAR-PROPOSAL-SCALE 5.0)))
  
  (set! loops-run-so-far (+ loops-run-so-far 1))
  (save-variable! RESUME-PATH 'loops-run-so-far)
  
  (if (<= mcmc-dual-loop-i TOTAL-OUTER-LOOPS) (mcmc-dual-loop (+ mcmc-dual-loop-i 1))))

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;; END Main MH loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

(exit)
