#!/usr/bin/perl

# this looks in condor_files and creates a submit_condor.txt file that will submit to condor
# the lisping of all of those files!

use strict;

my $myroot = "/data/scratch/piantado/SFL-huge/Vicare";
my $outdir = "run";
my $top = "100";
my $dorefresh = 1;
my @INHYTS = ("RAW",);# "NONCRAZY");

my $unique = 42612030;

# You need LD_LIBRARY_PATH=/data/scratch/piantado/SFL-small with libgmp.so.3 in that library path. 
print <<EOT;

Universe 	= vanilla
Executable 	= /data/scratch/piantado/vicare-0.1d5/src/vicare
notification    = Never
environment 	= VICARE_LIBRARY_PATH=/data/scratch/piantado/vicare-0.1d5:/data/scratch/piantado/vicare-0.1d5/lib/:/data/scratch/piantado/Libraries/r6rs-scheme:$myroot:\$VICARE_LIBRARY_PATH;LD_LIBRARY_PATH=/data/scratch/piantado/vicare-0.1d5:/data/scratch/piantado/vicare-0.1d5/lib/:$myroot:\$LD_LIBRARY_PATH;LOT_LIB_PATH=/data/scratch/piantado/Libraries/LOT-lib/;
requirements = (machine != "cocosci-1.csail.mit.edu") && (machine != "modesty.csail.mit.edu") && (machine != "delaware.csail.mit.edu") && ( machine != "128.30.108.60") && (Memory >= 3000) && (machine != "128.30.112.24") && (machine != "128.30.112.27")

#nice_user    = True

# MAX_JOBS_RUNNING = 10

EOT


my %running;
open(CQ, "condor_q piantado | ");
while(my $l = <CQ>) {
	$l =~ m/^\s[0-9]+\.([0-9]+)\s/;
	$running{$1} = 1;
}
close(CQ);

my $pid = 0;
# 
# 
# 
# ########################################################################################################
# ####### Do All concepts
# ########################################################################################################
# 
# foreach my $language ("Language-FOL-Both",){

#  foreach my $language ("Language-SimpleBoolean") {
#Language-FullBoolean", "Language-SimpleBoolean", "Language-CNF", "Language-DNF", "Language-Biconditional",
 foreach my $language ("Language-FullBoolean", "Language-SimpleBoolean", "Language-CNF", "Language-DNF", "Language-Biconditional",
 		"Language-LAM-QEF-EOQ-Q2O-SMC", "Language-LAM-QEF-EOQ-Q2O", "Language-LAM-QEF-EOQ-SMC", "Language-LAM-QEF-EOQ", "Language-LAM-QEF-Q2O-SMC", "Language-LAM-QEF-Q2O", "Language-LAM-QEF-SMC", "Language-LAM-QEF", "Language-LAM-EOQ-Q2O-SMC", "Language-LAM-EOQ-Q2O", "Language-LAM-EOQ-SMC", "Language-LAM-EOQ", "Language-LAM-Q2O-SMC", "Language-LAM-Q2O", "Language-LAM-SMC", "Language-LAM",) {
# 		"Language-LAM-QEF-EOQ-CRD-Q2O-SMC", "Language-LAM-QEF-EOQ-CRD-Q2O", "Language-LAM-QEF-EOQ-CRD-SMC", "Language-LAM-QEF-EOQ-CRD", "Language-LAM-QEF-EOQ-Q2O-SMC", "Language-LAM-QEF-EOQ-Q2O", "Language-LAM-QEF-EOQ-SMC", "Language-LAM-QEF-EOQ", "Language-LAM-QEF-CRD-Q2O-SMC", "Language-LAM-QEF-CRD-Q2O", "Language-LAM-QEF-CRD-SMC", "Language-LAM-QEF-CRD", "Language-LAM-QEF-Q2O-SMC", "Language-LAM-QEF-Q2O", "Language-LAM-QEF-SMC", "Language-LAM-QEF", "Language-LAM-EOQ-CRD-Q2O-SMC", "Language-LAM-EOQ-CRD-Q2O", "Language-LAM-EOQ-CRD-SMC", "Language-LAM-EOQ-CRD", "Language-LAM-EOQ-Q2O-SMC", "Language-LAM-EOQ-Q2O", "Language-LAM-EOQ-SMC", "Language-LAM-EOQ", "Language-LAM-CRD-Q2O-SMC", "Language-LAM-CRD-Q2O", "Language-LAM-CRD-SMC", "Language-LAM-CRD", "Language-LAM-Q2O-SMC", "Language-LAM-Q2O", "Language-LAM-SMC", "Language-LAM",) {
#foreach my $language ("Language-LAM-QEF-CRD-SMC", "Language-LAM-QEF-EOQ-CRD-SMC") {
	
	###################
# 	if($language !~ m/LAM/ && $language !~ m/Boolean|CNF|DNF|Biconditional/) { next; } # skip these for now

# foreach my $language (  "Language-RelationalSets", ){

foreach my $inhyt (@INHYTS) {

# if(! $running{$pid} ) { # if we don't see this process running
# 
# ## Copy over the previous version
# print STDERR "Removing $myroot/$outdir/CONCEPT_ALL__LANGUAGE_$language\__INHYT_$inhyt\__MODEL_parameterized-RR-noBeta/\n";
# system("mv $myroot/$outdir/CONCEPT_ALL__LANGUAGE_$language\__INHYT_$inhyt\__MODEL_parameterized-RR-noBeta/ $myroot/$outdir/CONCEPT_ALL__LANGUAGE_$language\__INHYT_$inhyt\__MODEL_parameterized-RR-noBeta-bak/");
# system("cp -R run_bak/run-2011Jul11pm/CONCEPT_ALL__LANGUAGE_$language\__INHYT_$inhyt\__MODEL_parameterized-RR-noBeta/ $myroot/$outdir/CONCEPT_ALL__LANGUAGE_$language\__INHYT_$inhyt\__MODEL_parameterized-RR-noBeta/");

print <<EOT;
Log		= $myroot/log-full/log_$language\_$inhyt-\$(Process).txt
Error		= $myroot/log-full/err_$language\_$inhyt-\$(Process).txt
Output		= /dev/null
# We have to load ikarus with the boot file

## NOTE: FOR THESE WE ARE RUNNING LESS REFRESHES, MORE LOOPS
Arguments	= -b /data/scratch/piantado/vicare-0.1d5/vicare.boot $myroot/HSFL-Full-Inference.scm -- DATA-PATH $myroot/concepts/ CONCEPTS ALL LANGUAGE $language MODEL  $myroot/models/parameterized-RR.scm DO-GRAMMAR-INFERENCE 1 IN-HYPOTHESES $myroot/mcmc-hypotheses/ OUT-PREFIX $myroot/$outdir/CONCEPT_ALL__LANGUAGE_$language\__INHYT_$inhyt\__MODEL_parameterized-RR-noBeta/ IN-TOP $top UNIQUE-ID $unique DO-REFRESH $dorefresh TOTAL-OUTER-LOOPS 600 MCMC-within-steps 10 MCMC-across-steps 10 MCMC-grammar-steps 10 LISTS L1,L2
Queue
# 

EOT

# }  #end if pid

$pid++;
$unique++;

}
}

# 
# ######################################################################################################
# ##### Other model types
# ######################################################################################################
# 
# 
foreach my $model ( "exemplar", "logistic", "response-biased", "poisson-length", "uniform"){ 

print <<EOT;
Log		= $myroot/log/log_$model-\$(Process).txt
Error		= $myroot/log/err_$model-\$(Process).txt
Output		= /dev/null
# We have to load ikarus with the boot file
Arguments	= -b /data/scratch/piantado/vicare-0.1d5/vicare.boot $myroot/HSFL-Full-Inference.scm -- DATA-PATH $myroot/concepts/ CONCEPTS ALL MODEL  $myroot/models/$model.scm LANGUAGE Language-QEF-LAM-CRD-UNQ DO-GRAMMAR-INFERENCE 0 IN-HYPOTHESES $myroot/mcmc-hypotheses/ OUT-PREFIX $myroot/$outdir/CONCEPT_ALL__LANGUAGE_NA__MODEL_$model/ IN-TOP $top UNIQUE-ID $unique DO-REFRESH 0 TOTAL-OUTER-LOOPS 600 MCMC-within-steps 10 MCMC-across-steps 10 MCMC-grammar-steps 10 
# Queue
EOT

$unique++;
}


########################################################################################################
####### Do boolean concepts
########################################################################################################

foreach my $ri ("",){#3,4,5,6,7,8,9,10) {
#  foreach my $language ("Language-SimpleBoolean") {
foreach my $language ( "Language-SimpleBoolean", "Language-OnlyFeatures", "Language-CNF", "Language-DNF", "Language-NAND", "Language-NOR", "Language-FullBoolean", "Language-Implies", "Language-Biconditional", "Language-HornClause") {

foreach my $inhyt (@INHYTS) {

print <<EOT;
Log		= $myroot/log/log$ri\_$language\_$inhyt-\$(Process).txt
Error		= $myroot/log/err$ri\_$language\_$inhyt-\$(Process).txt
Output		= /dev/null
# We have to load ikarus with the boot file
Arguments	= -b /data/scratch/piantado/vicare-0.1d5/vicare.boot $myroot/HSFL-Full-Inference.scm -- DATA-PATH $myroot/concepts/ CONCEPTS BOOLEAN LANGUAGE $language MODEL  $myroot/models/parameterized-RR.scm DO-GRAMMAR-INFERENCE 1 IN-HYPOTHESES $myroot/mcmc-hypotheses/ OUT-PREFIX $myroot/$outdir$ri/CONCEPT_BOOLEAN__LANGUAGE_$language\__INHYT_$inhyt\__MODEL_parameterized-RR-noBeta/ IN-TOP $top UNIQUE-ID $unique DO-REFRESH $dorefresh MCMC-within-steps 10 MCMC-across-steps 10 MCMC-grammar-steps 10  TOTAL-OUTER-LOOPS 600
Queue 

EOT

$unique++;
}
}
}


foreach my $model ( "exemplar", "logistic", "response-biased", "poisson-length", "uniform"){ 

print <<EOT;
Log		= $myroot/log/log_$model-\$(Process).txt
Error		= $myroot/log/err_$model-\$(Process).txt
Output		= /dev/null
# We have to load ikarus with the boot file
Arguments	= -b /data/scratch/piantado/vicare-0.1d5/vicare.boot $myroot/HSFL-Full-Inference.scm -- DATA-PATH $myroot/concepts/ CONCEPTS BOOLEAN MODEL $myroot/models/$model.scm LANGUAGE Language-Biconditional DO-GRAMMAR-INFERENCE 0 IN-HYPOTHESES $myroot/mcmc-hypotheses/ OUT-PREFIX $myroot/$outdir/CONCEPT_BOOLEAN__LANGUAGE_NA__MODEL_$model/ IN-TOP $top UNIQUE-ID $unique DO-REFRESH 0 TOTAL-OUTER-LOOPS 500 MCMC-within-steps 10 MCMC-across-steps 10 MCMC-grammar-steps 10 
# Queue

EOT

$unique++;
}

#/usr/local/bin/ikarus  /data/scratch/piantado/SFL-small/SFL-Inference.scm DATA-FILE /data/scratch/piantado/SFL-small/concepts/

sub seq {
	my $min = $_[0];
	my $max = $_[1];
	my $step = $_[2];

	my @o;
	for(my $i=$min;$i<=$max;$i += $step) {
		push @o, $i;
	}

	return @o;
}




