
# Run on parallel via: parallel -j4 < run-model-comparison.sh

# This calls HSF-Full-Inference to do the real model comparison
# that we use for final results


###########################################################################################
## Inference for complex concepts
###########################################################################################

vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-SetBased OUT-PREFIX run/final/All-Parameterized-SetBased/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-FOL OUT-PREFIX run/final/All-Parameterized-FOL/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-Base OUT-PREFIX run/final/All-Parameterized-Base/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-SimpleBoolean OUT-PREFIX run/final/All-Parameterized-SimpleBoolean/

vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-SetBased OUT-PREFIX run/final/All-Flat-SetBased/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-FOL OUT-PREFIX run/final/All-Flat-FOL/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-Base OUT-PREFIX run/final/All-Flat-Base/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-SimpleBoolean OUT-PREFIX run/final/All-Flat-SimpleBoolean/

###########################################################################################
## Inference on boolean concepts
###########################################################################################
 
vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-SimpleBoolean OUT-PREFIX run/final/Boolean-Parameterized-SimpleBoolean/
vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-NAND OUT-PREFIX run/final/Boolean-Parameterized-NAND/
vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-CNF OUT-PREFIX run/final/Boolean-Parameterized-CNF/
vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL parameterized-PCFG DO-GRAMMAR-INFERENCE 1 LANGUAGE Language-DNF OUT-PREFIX run/final/Boolean-Parameterized-DNF/

vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-SimpleBoolean OUT-PREFIX run/final/Boolean-Flat-SimpleBoolean/
vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-NAND OUT-PREFIX run/final/Boolean-Flat-NAND/
vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-CNF OUT-PREFIX run/final/Boolean-Flat-CNF/
vicare HSFL-Full-Inference.scm -- CONCEPT BOOLEAN MODEL flat-PCFG DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-DNF OUT-PREFIX run/final/Boolean-Flat-DNF/

###########################################################################################
## Non-rule-based methods (compare to flat-PCFG wtih Flat-Base)
###########################################################################################

vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL exemplar DO-GRAMMAR-INFERENCE 0 OUT-PREFIX run/final/All-Other-exemplar/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL logistic DO-GRAMMAR-INFERENCE 0 OUT-PREFIX run/final/All-Other-logistic/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL response-biased DO-GRAMMAR-INFERENCE 0 OUT-PREFIX run/final/All-Other-response-biased/

###########################################################################################
## Other ways to assign probabilities to rules
###########################################################################################

vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL poisson-length DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-Base OUT-PREFIX run/final/All-Flat-poisson-length/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL ptrue DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-Base OUT-PREFIX run/final/All-Flat-ptrue/
vicare HSFL-Full-Inference.scm -- CONCEPT ALL MODEL uniform DO-GRAMMAR-INFERENCE 0 LANGUAGE Language-Base OUT-PREFIX run/final/All-Flat-uniform/




